
(ns categorical.monad)
(use 'clojure.contrib.monads)

(in-ns 'categorical.monad)

;; To implement nondeterministic programs, we'll use a lazy seq to represent a value which may be any one of the members of seq.

(defmonad amb
  [
   m-result (fn[& vals] (cons 'amb vals))
   m-bind (fn[amb-seq f] (cons 'amb (map f (rest amb-seq))))
   ]
)
